/* Copyright (C) 2005, 2006 Hartmut Holzgraefe, MySQL AB

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>

#include <mysql.h>

static char *server_options[] = { "bug32624", NULL };

int num_elements = (sizeof(server_options) / sizeof(char *)) - 1;

static char *server_groups[] = { "embedded", "server",  "this_program_SERVER",  (char*)NULL};

int main(void)
{
  mysql_library_init(num_elements, server_options, server_groups); 

  int clientflag = CLIENT_FOUND_ROWS | CLIENT_MULTI_QUERIES | CLIENT_MULTI_STATEMENTS;

  MYSQL *mysql = mysql_init(NULL);

  mysql_options(mysql, MYSQL_READ_DEFAULT_GROUP, "libmysqld_client");
  mysql_options(mysql, MYSQL_OPT_USE_EMBEDDED_CONNECTION, NULL);

  if (NULL == mysql_real_connect(mysql, "localhost", "root", "", "mysql", 0,NULL,clientflag)) {
	printf("no connect: %s\n", mysql_error(mysql)); exit(3);
  }

  printf("%s\n", mysql_get_server_info(mysql));

  printf("%d\n",  mysql_next_result(mysql));

  mysql_query(mysql, "SELECT User FROM user; SELECT * from no_such_table");

  while (mysql_more_results(mysql)) {
	MYSQL_RES *res;

	printf("%d\n",mysql_next_result(mysql)); 

	res = mysql_store_result(mysql);
	if (res) {
	  mysql_free_result(res);
	} else {
	  printf("%s\n", mysql_error(mysql));
	}
  }

  mysql_close(mysql);
  mysql_library_end();
  return 0;
}
